<template lang="pug">
    v-card
        v-card-title Header
        v-card-text
            v-text-field(
                :value="projectCode"
                label="Project Code"
                filled
                readonly
            )
            v-text-field(
                :value="siteNumber"
                label="Site Number"
                filled
                readonly
            )
            v-text-field(
                :value="trenchNumber"
                label="Trench Number"
                filled
                readonly
            )
            v-text-field(
                :value="contextType"
                label="Context Type"
                filled
                readonly
            )
            v-text-field(
                v-model.number="localContextHeader.contextNumber"
                label="Context Number"
                v-on:input="grabChange"
            )
            v-autocomplete(
                v-model="localContextHeader.contextSameAs"
                label="Same as Context"
                :search-input.sync="searchSameAs"
                :items="searchSameAsContexts"
                chips
                deletable-chips
                multiple
                cache-items
                hide-selected
            )
</template>

<script>
import { debounce } from "debounce";
import { mapGetters, mapActions } from "vuex";
export default {
    name: "contextHeader",
    props: {
        projectCode: {
            required: true,
            type: String
        },
        siteNumber: {
            required: true,
            type: Number
        },
        trenchNumber: {
            required: true,
            type: Number
        },
        contextType: {
            required: true,
            type: String
        },
        contextHeader: {
            required: true,
            type: Object
        }
    },
    data: function() {
        return {
            localContextHeader: {},
            searchSameAs: "",
            searchSameAsContexts: []
        };
    },
    created: function() {
        this.localContextHeader = this.contextHeader;
    },
    computed: {
        ...mapGetters({
            getAllSearch: "contexts/getAllSearch",
            getATrench: "trench/getATrench"
        })
    },
    methods: {
        ...mapActions({
            fetchAllSearch: "search/fetchAllSearch"
        }),
        valueChanged: function() {
            this.$emit("input", {
                context: "ContextHeader",
                data: this.localContextHeader
            });
        },
        grabChange: function(element, value) {
            if (value) {
                this.localContextHeader[element] = value;
                this.valueChanged();
            }
        }
    },
    watch: {
        searchSameAs: debounce(function() {
            if (!this.searchSameAs || this.searchSameAs.trim() === "") {
                return;
            }
            this.fetchAllSearch({
                url: this.getATrench.data.relationships.contexts.links.related,
                options: {
                    params: {
                        likenumber: this.searchSameAs
                    }
                }
            }).then(response => {
                if (!response.data) {
                    return [];
                }
                this.searchSameAsContexts = response.data.map(el => {
                    return {
                        text: el.attributes.number.toString(),
                        value: el.id
                    };
                });
            });
        }, 500)
    }
};
</script>
